> This page is for Developer.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.bigcommerce.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.bigcommerce.com/_mcp/server.

# Update User Details

PUT https://api-b2b.bigcommerce.com/api/v3/io/users/{userId}
Content-Type: application/json

Updates the B2B Edition user account associated with `userId`. All fields may be updated except `companyId` and `originChannelId`, which are read-only for a user account.

Reference: https://docs.bigcommerce.com/developer/api-reference/rest/b2b/management/users/companies-user-update

## Authentication

- `X-Auth-Token` header (required) — | Header | Argument | Description | |:-------|:---------|:------------| | `X-Auth-Token` | `access_token` | For more about API accounts that generate `access_token`s, see our [Guide to API Accounts](/developer/docs/overview/api-fundamentals/api-accounts). | For example requests and more information about authenticating BigCommerce APIs, see [Authentication and Example Requests](/developer/docs/overview/api-fundamentals/api-accounts#x-auth-token-header-example-requests). For more about BigCommerce OAuth scopes, see our [Guide to API Accounts](/developer/docs/overview/api-fundamentals/api-accounts#oauth-scopes). For a list of API status codes, see [API Status Codes](/developer/api-reference/rest/overview#rest-http-status-codes).
- `X-Store-Hash` header (required) — | Header | Argument | Description | |:-------|:---------|:------------| | `X-Store-Hash` | `store_hash` | The unique store hash associated with a BigCommerce store that has B2B Edition enabled. |

## Request

### Path parameters

- `userId` (integer, required) — The unique identifier of the user as reported by [Get All Users](#get-all-users).

### Body (application/json)

This endpoint expects an object.

- `firstName` (string, optional) — User's first name.
- `lastName` (string, optional) — User's last name.
- `email` (string, optional) — User's email address. This must be unique within B2B Edition.
- `phoneNumber` (string, optional) — User's phone number.
- `role` (enum, optional) — Numeric code representing the user's role as admin (`0`), senior buyer (`1`), or junior buyer (`2`).
  - Allowed values: `0`, `1`, `2`
- `companyRoleId` (integer, optional) — Numeric code representing the user's Company-specific role. When present this field overrides the value of the `role` field.
- `uuid` (string, optional) — External identifier for the user. This field may be used to represent any external user ID. Using the name `uuid`, B2B Edition does not require the field to be unique.
- `extraFields` (list of extraField, optional)
- `channelIds` (list of integer, optional) — List of numeric channel IDs the user is associated with. These represent the storefront channels the user can log in to and do business.

## Response

### 200

Success

- `code` (integer, optional, default: 200) — Operation status code.
- `data` (userResponse, optional)
- `meta` (UsersUserIdPutResponsesContentApplicationJsonSchemaMeta, optional)

## Errors

### 404 Not Found Error

Not Found

- `code` (integer, optional, default: 404) — Operation status code.
- `data` (UsersUserIdPutResponsesContentApplicationJsonSchemaData, optional)
- `meta` (UsersUserIdPutResponsesContentApplicationJsonSchemaMeta, optional)

### 422 Unprocessable Entity Error

Validation Error

- `code` (integer, optional, default: 422) — Operation status code.
- `data` (UsersUserIdPutResponsesContentApplicationJsonSchemaData, optional)
- `meta` (UsersUserIdPutResponsesContentApplicationJsonSchemaMeta, optional)

## Types

### extraField

- `fieldName` (string, optional) — The name of the extra field displayed in B2B Edition.
- `fieldValue` (string, optional) — The user-specific value of the extra field.

### userResponse

- `id` (integer, optional)
- `firstName` (string, optional) — User's first name.
- `lastName` (string, optional) — User's last name.
- `email` (string, optional) — User's email address. This must be unique within B2B Edition.
- `phoneNumber` (string, optional) — User's phone number.
- `role` (enum, optional) — Numeric code representing the user's role as admin (`0`), senior buyer (`1`), or junior buyer (`2`).
  - Allowed values: `0`, `1`, `2`
- `companyRoleId` (integer, optional) — Numeric code representing the user's Company-specific role. When present this field overrides the value of the `role` field.
- `uuid` (string, optional) — External identifier for the user. This field may be used to represent any external user ID. Using the name `uuid`, B2B Edition does not require the field to be unique.
- `extraFields` (list of extraField, optional)
- `companyId` (integer, optional) — The unique numeric ID associated with the user's B2B Edition Company account.
- `createdAt` (integer, optional) — The [Unix timestamp](https://www.unixtimestamp.com/) for when the user's account was created.
- `updatedAt` (integer, optional) — The [Unix timestamp](https://www.unixtimestamp.com/) for when the user's account was last modified.
- `customerId` (integer, optional) — The unique numeric ID associated with the user's BigCommerce customer account.
- `companyRoleName` (string, optional) — Display name of the user's Company-specific role.
- `channelList` (list of UserResponseChannelListItems, optional) — Channels the user is assigned to.

### UsersUserIdPutResponsesContentApplicationJsonSchemaMeta

- `message` (string, optional, default: Parameter Error) — Human-readable status message.

### UsersUserIdPutResponsesContentApplicationJsonSchemaData

- `errMsg` (UsersUserIdPutResponsesContentApplicationJsonSchemaDataErrMsg, optional)

### UserResponseChannelListItems

- `channelId` (integer, optional) — The unique numeric ID associated with the channel.
- `channelName` (string, optional) — The display name of the channel, as shown in BigCommerce.
- `iconUrl` (string, optional) — The icon associated with the channel's type.

### UsersUserIdPutResponsesContentApplicationJsonSchemaDataErrMsg

- `_fieldName` (list of string, optional) — A variable field based on the errors in the request. A different `_fieldName` will be included for each reportable error. For example, if the email address is improperly formatted, the field will be called `email`.

## Examples

**Request**

```json
{}
```

**Response**

```json
{
  "code": 200,
  "data": {
    "id": 1,
    "firstName": "Marie",
    "lastName": "Curie",
    "email": "john.doe@example.com",
    "phoneNumber": "+1-555-123-4567",
    "role": 1,
    "companyRoleId": 10,
    "uuid": "user-uuid-1",
    "extraFields": [
      {
        "fieldName": "customField1",
        "fieldValue": "value1"
      }
    ],
    "companyId": 42,
    "createdAt": 1,
    "updatedAt": 1,
    "customerId": 12345,
    "companyRoleName": "Approver",
    "channelList": [
      {
        "channelId": 1,
        "channelName": "Default Storefront",
        "iconUrl": "https://s3.amazonaws.com/bc-channel-platform/channel-icons/bigcommerce.svg"
      }
    ]
  },
  "meta": {
    "message": "Success"
  }
}
```

**SDK Code**

```python
import requests

url = "https://api-b2b.bigcommerce.com/api/v3/io/users/123"

payload = {}
headers = {
    "X-Auth-Token": "<apiKey>",
    "Content-Type": "application/json"
}

response = requests.put(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api-b2b.bigcommerce.com/api/v3/io/users/123';
const options = {
  method: 'PUT',
  headers: {'X-Auth-Token': '<apiKey>', 'Content-Type': 'application/json'},
  body: '{}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api-b2b.bigcommerce.com/api/v3/io/users/123"

	payload := strings.NewReader("{}")

	req, _ := http.NewRequest("PUT", url, payload)

	req.Header.Add("X-Auth-Token", "<apiKey>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api-b2b.bigcommerce.com/api/v3/io/users/123")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Put.new(url)
request["X-Auth-Token"] = '<apiKey>'
request["Content-Type"] = 'application/json'
request.body = "{}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.put("https://api-b2b.bigcommerce.com/api/v3/io/users/123")
  .header("X-Auth-Token", "<apiKey>")
  .header("Content-Type", "application/json")
  .body("{}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('PUT', 'https://api-b2b.bigcommerce.com/api/v3/io/users/123', [
  'body' => '{}',
  'headers' => [
    'Content-Type' => 'application/json',
    'X-Auth-Token' => '<apiKey>',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api-b2b.bigcommerce.com/api/v3/io/users/123");
var request = new RestRequest(Method.PUT);
request.AddHeader("X-Auth-Token", "<apiKey>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "X-Auth-Token": "<apiKey>",
  "Content-Type": "application/json"
]
let parameters = [] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api-b2b.bigcommerce.com/api/v3/io/users/123")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "PUT"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```